package com.platform.acme.mailinglist;

import com.platform.api.*;
import java.util.*;

public class AddUpdateController_YOURNAME implements com.platform.api.Controller
{
    /**
     * Substitute project name or your name to personalize the error message.
     */
    public void debug(String text) {
        Logger.info(text, "YOURNAME Class");        
    }	
    public void errMsg(String text, String exceptionMsg) {
        debug(text + ":\n  " + exceptionMsg);        
    }

   /**
    * Personalize the target page below, as well.
    */
    public ControllerResponse execute(HashMap valueMap) throws Exception
    {
        String page_action = (String)valueMap.get("action");
        debug("Code is running: " + page_action);

        ControllerResponse cr = new ControllerResponse();
        cr.setTargetPage("AddUpdateYOURNAME.jsp");

        // Uncomment this to see all incoming parameters
        //debug("valueMap= " + valueMap);
        
        if ( page_action.equals("Add") ) {            
            String email = (String)valueMap.get("contact_email");
            HashMap values = find(email);
            if (values == null) {
               // No existing record. Add the new one
               add(valueMap);
               valueMap.put("control", "record_added");
           } else {
               // Email address already exists.  
               // Add existing name and record ID to current parameters,
               // and see what user wants to do next
               valueMap.put("existing_name", values.get("existing_name") );
               valueMap.put("record_id", values.get("record_id") );
               valueMap.put("control", "update_query");
            }          
       } else if ( page_action.equals("Update") ) {
            update(valueMap);
            valueMap = new HashMap();
            valueMap.put("control", "record_updated");
        } else {
            // User clicked "Cancel" after an update query.
            // Go to initial state
            valueMap = new HashMap();
            valueMap.put("control", "init");
        }
        cr.setData(valueMap);
        return cr;
    }
  
    /**
     * Find a Mailing List record that has a specified email address
     * @return null if a record with a matching email address is not found. 
     *         Otherwise, return a Parameters object with record ID (for an update)
     *         and the existing name (to see if user wants to update).
     */
    public HashMap find(String email) throws Exception {
        String existing_name = "";
        String existing_id = "";
        HashMap valueMap = null;
        try {            
            String query = "SELECT id, contact_name FROM Mailing_List "
                         + "WHERE contact_email = '" + email + "'";
            Result result = Functions.execSQL(query);
            int resultCode = result.getCode();
            if (resultCode < 0) {
                errMsg( "Error during SQL search", result.getMessage() );        
           } else if (resultCode > 0) {
                // A record was found. (Otherwise, resultCode == 0)                    
                ParametersIterator it = result.getIterator();
                Parameters result_params = it.next();  // Use a loop if Limit > 1  
                valueMap = new HashMap();    
                valueMap.put( "existing_name", result_params.get("contact_name") );
                valueMap.put( "record_id", result_params.get("id") );
            }
        } catch (Exception e) {
            errMsg( "Exception during SQL search", e.getMessage() );        
        }
        return valueMap;
    }
  
    public Result add(HashMap valueMap) throws Exception
    {
        Result result = null;
        try {
            Parameters params = Functions.getParametersInstance();
            params.add(valueMap);
            result = Functions.addRecord("Mailing_List", params);
        } catch (Exception e) {
            errMsg( "Exception adding record", e.getMessage() );        
        }
        return result;
    }
    
    /**
     * Update a Mailing List record. Incoming value map has record_id 
     * and contact_name for the update.
     */
    public Result update(HashMap valueMap) throws Exception
    {
        Result result = null;
        try {
           Parameters params = Functions.getParametersInstance();
           params.add(valueMap);
           String record_id = (String) params.get("record_id");
           result = Functions.updateRecord("Mailing_List", record_id, params);
        } catch (Exception e) {
            errMsg( "Exception updating record", e.getMessage() );        
        }
        return result;
    }
}